package pak;

/**
 * Byte-swabbing methods
 */
public class Swab
{
    /**
     * Swab an int
     * @param v the int to swab
     * @return The int after swabbing
     */
    public final static int I(int v)
    {
        return  (v >>> 24) | (v << 24) |
        ((v << 8) & 0x00FF0000) | ((v >> 8) & 0x0000FF00);
    }
    
    /**
     * Swab a short
     * @param v The short to swab
     * @return The swabbed short, padded to an int
     */
    public final static short S(int v)
    {
        return (short)(((0xFF00 & v) >>> 8 ) | ((v << 8) & 0x0000FF00));
    }
    
}