package pak;

import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

public class ZipDirModel extends AbstractTableModel
{
	RandomAccessFile braf;
	int offset;
//JDK150	ArrayList<Zipf> zfl;
	ArrayList zfl;


	static String tstr[] = {"Other", "Material", "Texture"};
	static String [] header = { "In", "Filename", "Path", "Size", "Type"};
        static Object [] cols = { Boolean.TRUE, "", "", "", ""};
   

//JDK150	public ZipDirModel(ArrayList<Zipf>zipfilelist)
	public ZipDirModel(ArrayList zipfilelist)
	{
		zfl = zipfilelist;
	}

//JDK150	public void setziplist(ArrayList<Zipf>zipfilelist)
	public void setziplist(ArrayList zipfilelist)
	{
		zfl = zipfilelist;
	}

	public Zipf getzipfile(int row)
	{
		if(zfl != null)
//JDK150			return zfl.get(row);
			return (Zipf)zfl.get(row);
		return null;	// handle empty pak
	}

	public int getRowCount() {
		if(zfl != null)
			return zfl.size();	
		else
			return 0;	// handle empty pak
	}
    
	public int getColumnCount() {
		return 5;
	}
        
        public Class getColumnClass(int col) {
           return cols[col].getClass();
        }
    
	public Object getValueAt(int row,int col)
	{
      	  
	      switch(col)
		{
			case 0:
                        return new Boolean(getzipfile(row).inpak);
                  case 1:
				return getzipfile(row).filename;
			case 2:
				return getzipfile(row).pathname;
			case 3:
				return new Integer(getzipfile(row).size);
			case 4:
				return tstr[gettype(row)];
                        
		}
		return null;
	}
   
	
  	public void setValueAt(Object value, int row, int col)
	{
		switch(col)
		{
			case 1:
				getzipfile(row).setfile((String)value);
				getzipfile(row).settype();
				break;
			case 2:
				getzipfile(row).setpath((String)value);
				break;
			default:
				break;
		}
		fireTableDataChanged();

		return;
	}
		

	public String getColumnName(int col) {
		return header[col];
	}
	
	public void setfileparams(RandomAccessFile r, int o)
	{
		braf = r;
		offset = o;
	}
	
	public RandomAccessFile getbuff() {
		return braf;
	}
	
	public int getoffset()
	{
		return offset;
	}

	public int gettype(int i)
	{
		return getzipfile(i).type;
	}

	public String getfilename(int i)
	{
		return getzipfile(i).filename;
	}
        
        public void deletefile(int row)
        {
            if(row>=0 && row<zfl.size())
                zfl.remove(row);
            fireTableDataChanged();
        }
        
        public void addfile(Zipf zip)
        {
		zfl.add(zip);
            fireTableDataChanged();
        }
 }
